import { DebugElement } from '@angular/core';
import { TestBed, async, ComponentFixture,tick ,fakeAsync,flush} from '@angular/core/testing';
import {FormsModule} from '@angular/forms'
import { By } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import { WjGridModule, WjFlexGrid } from '@grapecity/wijmo.angular2.grid';
import { WjInputModule, WjInputNumber, WjComboBox } from '@grapecity/wijmo.angular2.input';
import { FlexGrid } from '@grapecity/wijmo.grid';
import * as wjCore from "@grapecity/wijmo";
import { ComboBox } from '@grapecity/wijmo.input';
// wjCore.setLicenseKey("");
describe('AppComponent', () => {
  let appComponent: ComponentFixture<AppComponent>;
    let appComDebugElement: DebugElement;
    let myComponent: AppComponent;
    let myNativeElement: Element;
    let gridDebugElement: DebugElement;
    let grid: FlexGrid;
    let gridNativeElement: HTMLElement;
    let comboDebugElement: DebugElement;
    let comboBox :ComboBox;
  beforeEach(async(() => {
    
    TestBed.configureTestingModule({
      declarations: [
        AppComponent
      ],
      imports:[
        WjGridModule,
        WjInputModule,
        FormsModule
      ]
    }).compileComponents();
    appComponent = TestBed.createComponent(AppComponent);
    appComDebugElement = appComponent.debugElement;
    myComponent = appComDebugElement.componentInstance;
    myNativeElement = appComDebugElement.nativeElement as Element;
    gridDebugElement = appComDebugElement.query(By.directive(WjFlexGrid));
    gridNativeElement = gridDebugElement.nativeElement;
    
    grid = gridDebugElement.componentInstance;
    gridNativeElement = gridDebugElement.nativeElement;
    comboDebugElement = appComDebugElement.query(By.directive(WjComboBox));
    comboBox = comboDebugElement.componentInstance;
    appComponent.detectChanges();
  }));
  it('should create the app', () => {
    const app = appComDebugElement.componentInstance;
    expect(app).toBeTruthy();
  });
  // it(`should have licensed correctly" `, async(() => {
  //   const doc :Document | null = document;
  //   let el : Element|null = doc.querySelector('a[href*="grapecity.com"]');
  //   expect(el).toBeNull();
  //   if (el) {
  //       expect(el).toBeNull();
  //   }
  // }));
  it(`should have as title 'FlexGrid'`, () => {
    const app = appComDebugElement.componentInstance;
    expect(app.title).toEqual('FlexGrid');
  });
  it('should render title in a h1 tag', () => {
    // const fixture = TestBed.createComponent(AppComponent);
    appComponent.detectChanges();
    const compiled = myNativeElement;
    expect(compiled.querySelector('h1').textContent).toContain('FlexGrid');
  });
  // Wijmo Controls UnitTesting
  it('should fire initialized event', fakeAsync(() => {   
    // appComponent.detectChanges();
    spyOn(myComponent, 'initFlexGrid');
    // flush();
    // grid.ngAfterViewInit();
    tick(2000);
    // appComponent.detectChanges();
    appComponent.whenStable().then(() => {          
        expect(myComponent.initFlexGrid).toHaveBeenCalled();
    });
  }));
  it('should fire selectionChanged event', async(() => {
    appComponent.detectChanges();
    spyOn(myComponent, 'selectionChanged');
    grid.select(100, 100);
    expect(myComponent.selectionChanged).toHaveBeenCalled();
    appComponent.detectChanges();
  }));
  it(`should display the "Id" column header`, async(() => {
    const colHeaderCellElement: Element | null = gridNativeElement.querySelectorAll('.wj-colheaders .wj-cell.wj-header')[0];
    expect(colHeaderCellElement).not.toBeNull();
    if (colHeaderCellElement) {
        expect(colHeaderCellElement.textContent).toEqual('Id');
    }
  }));
  it(`should render the first country cell is "US" `, async(() => {
      const countryCellElement: Element | null = gridNativeElement.querySelectorAll("[role='gridcell']")[1];
      expect(countryCellElement).not.toBeNull();
      if (countryCellElement) {
          expect(countryCellElement.textContent).toEqual('US');
      }
  }));
  it('should have touched',fakeAsync(()=>{    
    let el : HTMLInputElement|null =comboDebugElement.nativeElement.querySelector("input.wj-form-control");
    appComponent.detectChanges();
    comboBox.focus(); // simulate focus ComboBox    
    comboBox.onLostFocus(); // simulate focusout
    el.blur(); // focusout from InputElement
    flush();
    appComponent.detectChanges ();
    expect(comboDebugElement.classes["ng-untouched"]).not.toBeTruthy();
    expect(comboDebugElement.classes["ng-touched"]).toBeTruthy();
  }));
});
