import { Component,ChangeDetectionStrategy, ViewChild, Inject} from '@angular/core';
import { FormControl } from '@angular/forms';

import {DataSvc} from './data'
import * as wjCore from "@grapecity/wijmo";
import * as wjGrid from "@grapecity/wijmo.grid";
import * as wjInput from '@grapecity/wijmo.input';
import { collectExternalReferences } from '@angular/compiler';


@Component({
  selector: 'app-root',
  templateUrl: './app.component.html',
  styleUrls: ['./app.component.scss']
})
export class AppComponent {
  title ="Wijmo 5";
  data =this.getData();
  
  customAgg(item,binding){
    if(item && binding){
      let _val =0;
      item.items.forEach(_i => {
        _val+= _i[binding];
      });
      return _val/item.items.length;
    }
    return "Not Implemented";
  }

  getData(){
    let countries = "US,UK,Japan,India,China".split(',');
    let products = "Wijmo,Spread,Active Report,ComponentOne".split(',');
    let colors= "Red,Blue,White,Green".split(',');    
    let data=[];
    for(let i=0;i<100;i++){
      data.push({
        id:i,
        country:countries[i%countries.length],
        product:products[i%products.length],
        sales:Math.random()*1000,
        downloads:Math.random()*1000,
        color:colors[i%colors.length],
        active:i%3==0
      })
    }
    return data;
  }
}
    